package com.impetus.kundera.entities;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.TableGenerator;

import com.impetus.kundera.index.Index;
import com.impetus.kundera.index.IndexCollection;

@Entity
@Table(name = "department")
// @IndexCollection(columns = { @Index(name = "dept_name"),
// @Index(name = "dept_code") })
// @NamedQueries({
// @NamedQuery(name = "retrieveDepartment", query =
// "select d from Department d where d.deptName = ?1"),
// @NamedQuery(name = "findDeptById", query =
// "select d from Department d where d.deptId = ?1") })
public class Department {

	// @Id
	// @Column(name = "dept_id")
	// @GeneratedValue(strategy = GenerationType.TABLE)
	@Id
	@Column(name = "dept_id")
	@TableGenerator(name = "id_gen", allocationSize = 1, initialValue = 1)
	@GeneratedValue(generator = "id_gen", strategy = GenerationType.TABLE)
	private Long deptId;

	@Column(name = "dept_name")
	private String deptName;

	@Column(name = "dept_code")
	private String deptCode;

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "deptId")
//	@ManyToOne(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
//	@JoinColumn(name = "dept_id")
	private List<Employee> employeeList;

	public Long getDeptId() {
		return deptId;
	}

	public void setDeptId(Long deptId) {
		this.deptId = deptId;
	}

	// public String getDeptId() {
	// return deptId;
	// }
	//
	// public void setDeptId(String deptId) {
	// this.deptId = deptId;
	// }

	public String getDeptName() {
		return deptName;
	}

	public void setDeptName(String employeeName) {
		this.deptName = employeeName;
	}

	public String getDeptCode() {
		return deptCode;
	}

	public void setDeptCode(String deptCode) {
		this.deptCode = deptCode;
	}

	public List<Employee> getEmployeeList() {
		return employeeList;
	}

	public void setEmployeeList(List<Employee> employeeList) {
		this.employeeList = employeeList;
	}

}
